## inspircd 2.0.27

=== debian/changelog ===
inspircd (2.0.27-1) unstable; urgency=medium

  * New upstream version 2.0.27 (Closes: #910462)
  * Add myself to uploaders

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Mon, 25 Feb 2019 21:28:51 +0100

inspircd (2.0.24-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Fix maintainer address. Closes: #899965
  * Remove alioth references and all uploaders who did not contribute
    in this decade

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 17 Jun 2018 21:06:10 +0200

=== debian/control ===
Source: inspircd
Section: net
Priority: optional
Maintainer: inspircd packagers <inspircd@packages.debian.org>
Uploaders:
     Guillaume Delacour <gui@iroqwa.org>,
     Christoph Biedl <debian.axhn@manchmal.in-ulm.de>,
Build-Depends: debhelper (>= 9.0.0), perl, libgnutls28-dev, pkg-config,
               libldap2-dev, libpcre3-dev, default-libmysqlclient-dev, libpq-dev,
               libsqlite3-dev, zlib1g-dev, libgeoip-dev,
               libtre-dev, dh-systemd (>= 1.5), dh-apparmor
Standards-Version: 3.9.8
Homepage: http://www.inspircd.org/

Package: inspircd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
Suggests: sqlite3, default-mysql-server, ldap-server, postgresql, gnutls-bin
Provides: ircd
Description: Modular IRCd written in C++
 InspIRCd is a modular C++ IRC Daemon for several operating systems created
 to provide a stable, modern, lightweight irc server from scratch and provide
 a vast number of features in a modularised form using an advanced module API.
 By keeping the functionality of the main core to a minimum, the server is very
 stable, fast and customizable.
 .
 This package contains the daemon.

Package: inspircd-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends}, inspircd (= ${binary:Version})
Priority: extra
Description: Modular IRCd written in C++ - debugging symbols
 InspIRCd is a modular C++ IRC Daemon for several operating systems created
 to provide a stable, modern, lightweight irc server from scratch and provide
 a vast number of features in a modularised form using an advanced module API.
 By keeping the functionality of the main core to a minimum, the server is very
 stable, fast and customizable.
 .
 This package contains the debugging symbols.

Package: inspircd-dev
Architecture: any
Depends: ${misc:Depends}
Description: Modular IRCd written in C++ - development headers
 InspIRCd is a modular C++ IRC Daemon for several operating systems created
 to provide a stable, modern, lightweight irc server from scratch and provide
 a vast number of features in a modularised form using an advanced module API.
 By keeping the functionality of the main core to a minimum, the server is very
 stable, fast and customizable.
 .
 This package contains the development headers for developing modules.

## inspircd 3.4.0

=== win/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(InspIRCd CXX)

set(CONFIG_DIR "conf" CACHE PATH "Configuration file path")
set(MODULE_DIR "modules" CACHE PATH "Module path")
set(DATA_DIR "data" CACHE PATH "Data path")
set(LOG_DIR "logs" CACHE PATH "Log file path")

set(EXTRA_INCLUDES "" CACHE PATH "Extra include paths")
set(EXTRA_LIBS "" CACHE PATH "Extra library paths")

set(INSPIRCD_BASE "${CMAKE_CURRENT_SOURCE_DIR}/../")

# Build with multiple processes
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

# Use our own NSIS template
set(CMAKE_MODULE_PATH "${INSPIRCD_BASE}/win")

# Grab version info from version.sh
file(STRINGS "${INSPIRCD_BASE}/src/version.sh" VERSIONSH)
string(REGEX REPLACE ".*InspIRCd-([0-9]*).*" "\\1" VERSION_MAJOR "${VERSIONSH}")
string(REGEX REPLACE ".*InspIRCd-[0-9]*\\.([0-9]*).*" "\\1" VERSION_MINOR "${VERSIONSH}")
string(REGEX REPLACE ".*InspIRCd-[0-9]*\\.[0-9]*\\.([0-9]*).*" "\\1" VERSION_PATCH "${VERSIONSH}")
string(REGEX REPLACE ".*InspIRCd-([^\"]+).*" "\\1" VERSION_FULL "${VERSIONSH}")

if(MSVC)
	# Without /SAFESEH:NO old libraries compiled with VS 2010 or older won't link correctly to VS2012 (eg, extra module libs)
	set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /SAFESEH:NO")
	set(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL} /SAFESEH:NO")
	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /SAFESEH:NO")
	set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /SAFESEH:NO")
	set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /SAFESEH:NO")
	set(CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "${CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL} /SAFESEH:NO")
	set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /SAFESEH:NO")
	set(CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} /SAFESEH:NO")
	set(CMAKE_MODULE_LINKER_FLAGS_DEBUG "${CMAKE_MODULE_LINKER_FLAGS_DEBUG} /SAFESEH:NO")
	set(CMAKE_MODULE_LINKER_FLAGS_MINSIZEREL "${CMAKE_MODULE_LINKER_FLAGS_MINSIZEREL} /SAFESEH:NO")
	set(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} /SAFESEH:NO")
	set(CMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO} /SAFESEH:NO")
endif(MSVC)

file(GLOB INSPIRCD_SOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
"${INSPIRCD_BASE}/win/inspircd_win32wrapper.cpp"
"${INSPIRCD_BASE}/win/win32service.cpp" "${INSPIRCD_BASE}/src/*.cpp"
"${INSPIRCD_BASE}/src/socketengines/socketengine_select.cpp"
"${INSPIRCD_BASE}/src/threadengines/threadengine_win32.cpp")
list(SORT INSPIRCD_SOURCES)

include_directories("${INSPIRCD_BASE}/win" "${INSPIRCD_BASE}/include")

include_directories(${EXTRA_INCLUDES})
link_directories(${EXTRA_LIBS})

if(MSVC)
	add_library(win32_memory STATIC "${INSPIRCD_BASE}/win/inspircd_memory_functions.cpp")
endif(MSVC)

configure_file("${INSPIRCD_BASE}/win/inspircd.rc.cmake" "${INSPIRCD_BASE}/win/inspircd.rc")
configure_file("${INSPIRCD_BASE}/make/template/config.h" "${INSPIRCD_BASE}/include/config.h")

add_executable(inspircd ${INSPIRCD_SOURCES} "${INSPIRCD_BASE}/win/inspircd.rc")
target_link_libraries(inspircd win32_memory)
set_target_properties(inspircd PROPERTIES ENABLE_EXPORTS ON)
install(TARGETS inspircd DESTINATION .)

add_subdirectory(modules)

# Package any DLLs in win/
file(GLOB EXTRA_DLLS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${INSPIRCD_BASE}/win/*.dll")
install(FILES ${EXTRA_DLLS} DESTINATION .)

# Install example configs
file(GLOB_RECURSE EXAMPLE_CONFIGS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${INSPIRCD_BASE}/docs/conf/*.example")
install(FILES ${EXAMPLE_CONFIGS} DESTINATION conf)

# Install nationalchars files
file(GLOB_RECURSE EXAMPLE_LOCALES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${INSPIRCD_BASE}/locales/*")
install(FILES ${EXAMPLE_LOCALES} DESTINATION locales)

# Create an empty data and logs directory and install them
file(MAKE_DIRECTORY ${DATA_DIR})
install(DIRECTORY ${DATA_DIR} DESTINATION .)
file(MAKE_DIRECTORY ${LOG_DIR})
install(DIRECTORY ${LOG_DIR} DESTINATION .)

if(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")
	set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION ".") # place runtime libraries next to InspIRCd binary
	include(InstallRequiredSystemLibraries)

	set(CPACK_PACKAGE_NAME "InspIRCd IRC Daemon")
	set(CPACK_PACKAGE_VENDOR "InspIRCd Development Team")
	set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
	set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
	set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
	set(CPACK_PACKAGE_FILE_NAME "InspIRCd-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../docs/LICENSE.txt")

	set(CPACK_GENERATOR "NSIS")
	set(CPACK_PACKAGE_INSTALL_DIRECTORY "InspIRCd")
	# NSIS has a bug with full nix paths, so this must contain at least one backslash
	set(CPACK_PACKAGE_ICON "${INSPIRCD_BASE}/win\\\\inspircd.ico")
	set(CPACK_NSIS_MUI_ICON "${INSPIRCD_BASE}/win\\\\inspircd.ico")
	set(CPACK_NSIS_MUI_UNIICON "${INSPIRCD_BASE}/win\\\\inspircd.ico")
	set(CPACK_NSIS_INSTALLED_ICON_NAME "inspircd.exe")
	set(CPACK_NSIS_URL_INFO_ABOUT "https://www.inspircd.org")
	set(CPACK_NSIS_COMPRESSOR "/SOLID zlib")

	include(CPack)
endif(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")

=== win/modules/CMakeLists.txt ===
# m_regex_stdlib is supported by every version of Visual Studio we support,
# so copy the file out of extra/
file(COPY "${INSPIRCD_BASE}/src/modules/extra/m_regex_stdlib.cpp" DESTINATION "${INSPIRCD_BASE}/src/modules/")

file(GLOB INSPIRCD_MODULES "${INSPIRCD_BASE}/src/coremods/core_*" "${INSPIRCD_BASE}/src/modules/m_*")
list(SORT INSPIRCD_MODULES)

add_definitions("-DDLL_BUILD")

file(GLOB INSPIRCD_VENDORS "${INSPIRCD_BASE}/vendor/**")
foreach(INSPIRCD_VENDOR ${INSPIRCD_VENDORS})
	if(NOT IS_DIRECTORY ${INSPIRCD_VENDOR})
		list(REMOVE_ITEM INSPIRCD_VENDORS ${INSPIRCD_VENDOR})
	endif()
endforeach()

foreach(MODULE_NAME ${INSPIRCD_MODULES})
	if(IS_DIRECTORY "${MODULE_NAME}")
		string(REGEX REPLACE "^.*[/\\](.*)$" "\\1" BASE_NAME ${MODULE_NAME})
	else(IS_DIRECTORY "${MODULE_NAME}")
		string(REGEX REPLACE "^.*[/\\](.*).cpp$" "\\1" BASE_NAME ${MODULE_NAME})
	endif(IS_DIRECTORY "${MODULE_NAME}")
	set(SO_NAME "${BASE_NAME}.so")

	if(IS_DIRECTORY "${MODULE_NAME}")
		file(GLOB MODULES_SUBDIR_SRCS "${MODULE_NAME}/*.cpp")
		list(SORT MODULES_SUBDIR_SRCS)
		add_library(${SO_NAME} MODULE ${MODULES_SUBDIR_SRCS})
	else(IS_DIRECTORY "${MODULE_NAME}")
		add_library(${SO_NAME} MODULE ${MODULE_NAME})
	endif(IS_DIRECTORY "${MODULE_NAME}")

	# Generate the module and set its linker flags, also set it to depend on the main executable to be built beforehand
	target_link_libraries(${SO_NAME} inspircd)
	add_dependencies(${SO_NAME} inspircd)
	target_include_directories(${SO_NAME} PRIVATE ${INSPIRCD_VENDORS})
	if(MSVC)
		target_link_libraries(${SO_NAME} win32_memory)
		add_dependencies(${SO_NAME} win32_memory)
	endif(MSVC)

	set_target_properties(${SO_NAME} PROPERTIES
		PREFIX ""
		SUFFIX ""
		COMPILE_DEFINITIONS "MODNAME=\"${BASE_NAME}\""
	)

	# Set the module to be installed to the module directory
	install(TARGETS ${SO_NAME} DESTINATION ${MODULE_DIR})
endforeach(MODULE_NAME ${INSPIRCD_MODULES})

=== debian/changelog ===
inspircd (3.4.0-2ubuntu1) focal; urgency=low

  [ Joel Sing ]
  * Merge from Debian unstable (LP: #1865518). Remaining changes:
    - d/p/15_ldapauth_logging.diff (rewritten against 3.4)
  * Drop changes:
    - d/p/20_close-open-logs-on-rehash.diff: functionality now available
      upstream.

  [ Robie Basak ]
  * d/rules: reenable m_ldap and m_regex_stdlib.cpp to prevent regression in
    shipped modules. Thanks to Joel Sing. Closes: #953259.

 -- Robie Basak <robie.basak@ubuntu.com>  Fri, 06 Mar 2020 23:26:40 +0000

inspircd (3.4.0-2) unstable; urgency=medium

  * Fix the pidfile location for apparmor support. Closes: #947281

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Tue, 24 Dec 2019 21:25:26 +0100

inspircd (3.4.0-1) unstable; urgency=medium

  * New upstream version 3.4.0
  * Restore GeoIP support. Closes: #936039
  * Remove Guillaume Delacour from uploaders, thanks for all your
    work on that package.

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Fri, 01 Nov 2019 12:38:53 +0100

inspircd (3.3.0-1) unstable; urgency=medium

  * New upstream version 3.3.0

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sat, 24 Aug 2019 20:17:53 +0200

inspircd (3.2.0-1) unstable; urgency=medium

  * New upstream version 3.2.0. Closes: #870858, #928759

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Mon, 05 Aug 2019 21:11:33 +0200

inspircd (2.0.27-1ubuntu2) eoan; urgency=medium

  * No change rebuild for libmysqlclient21.

 -- Robie Basak <robie.basak@ubuntu.com>  Mon, 12 Aug 2019 02:01:04 +0000

inspircd (2.0.27-1ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    + 15_ldapauth_logging.diff
    + 20_close-open-logs-on-rehash.diff

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 01 Mar 2019 14:42:57 +0100

inspircd (2.0.24-1.1ubuntu1) cosmic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    + 15_ldapauth_logging.diff
    + 20_close-open-logs-on-rehash.diff

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 25 Jun 2018 16:11:20 +0200

=== debian/control ===
Source: inspircd
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christoph Biedl <debian.axhn@manchmal.in-ulm.de>
Homepage: https://www.inspircd.org/
Standards-Version: 4.4.1
Build-Depends: debhelper-compat (= 12),
    default-libmysqlclient-dev,
    dh-apparmor,
    libgnutls28-dev,
    libhttp-parser-dev (>= 2.9),
    libldap2-dev,
    libmaxminddb-dev,
    libpcre3-dev,
    libpq-dev,
    libsqlite3-dev,
    libtre-dev,
    perl,
    pkg-config,
    zlib1g-dev,
Priority: optional
Section: net

Package: inspircd
Architecture: any
Pre-Depends:
    ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends},
    lsb-base,
Suggests:
    default-mysql-server,
    gnutls-bin,
    ldap-server,
    postgresql,
    sqlite3,
Provides:
    ircd,
Description: Modular IRCd written in C++
 InspIRCd is a modular C++ IRC Daemon for several operating systems created
 to provide a stable, modern, lightweight irc server from scratch and provide
 a vast number of features in a modularised form using an advanced module API.
 By keeping the functionality of the main core to a minimum, the server is very
 stable, fast and customizable.
 .
 This package contains the daemon.

Package: inspircd-dev
Architecture: all
Depends: ${misc:Depends},
Multi-Arch: foreign
Description: Modular IRCd written in C++ - development headers
 InspIRCd is a modular C++ IRC Daemon for several operating systems created
 to provide a stable, modern, lightweight irc server from scratch and provide
 a vast number of features in a modularised form using an advanced module API.
 By keeping the functionality of the main core to a minimum, the server is very
 stable, fast and customizable.
 .
 This package contains the development headers for developing modules.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export INSPIRCD_DISABLE_RPATH=1

# Upstream uses clang on FreeBSD. So force CXX to g++ if undefined, but
# still allow rebuilding with another compiler
CXX ?= g++

%:
	dh $@

override_dh_auto_clean:
	# call distclean instead of clean
	dh_auto_clean -- distclean

	# Delete symlinks to extra modules
	find $(CURDIR)/src/modules/ -type l -exec rm '{}' \;

	-rm debian/inspircd.service
	rm -rf build-man

override_dh_auto_configure:
	./configure --disable-interactive \
		--uid=irc \
		--gid=irc \
		--prefix=/usr/lib/inspircd \
		--config-dir=/etc/inspircd \
		--module-dir=/usr/lib/inspircd/modules \
		--example-dir=/usr/share/doc/inspircd/examples \
		--data-dir=/var/run/inspircd \
		--binary-dir=/usr/sbin
	./configure --disable-interactive \
		--enable-extras=m_ldap.cpp,m_regex_stdlib.cpp

override_dh_auto_build:
	dh_auto_build -- INSPIRCD_VERBOSE=1 all

override_dh_auto_install:
	dh_auto_install
	dh_apparmor --profile-name=usr.sbin.inspircd -pinspircd

override_dh_installman:
	mkdir build-man/
	for man in \
		inspircd.1 \
		inspircd-genssl.1 ; \
	do \
		sed -e 's/"1"/"8"/' \
			<"debian/tmp/usr/lib/inspircd/manuals/$$man" \
			>"build-man/$${man%%.1}.8" ; \
	done
	dh_installman

override_dh_installinit:
	dh_installinit --no-restart-after-upgrade

override_dh_installsystemd:
	if [ -f .configure/inspircd.service ] ; then \
		sed -e 's:=/var/run/:=/run/:' \
			<.configure/inspircd.service \
			>debian/inspircd.service ; \
	fi
	dh_installsystemd

## inspircd 3.8.1

=== win/CMakeLists.txt ===
--- 
+++ 
@@ -47,6 +47,13 @@
 "${INSPIRCD_BASE}/src/socketengines/socketengine_select.cpp"
 "${INSPIRCD_BASE}/src/threadengines/threadengine_win32.cpp")
 list(SORT INSPIRCD_SOURCES)
+
+file(GLOB INSPIRCD_VENDORS "${INSPIRCD_BASE}/vendor/**")
+foreach(INSPIRCD_VENDOR ${INSPIRCD_VENDORS})
+	if(IS_DIRECTORY ${INSPIRCD_VENDOR})
+		include_directories(${INSPIRCD_VENDOR})
+	endif()
+endforeach()
 
 include_directories("${INSPIRCD_BASE}/win" "${INSPIRCD_BASE}/include")

=== win/modules/CMakeLists.txt ===
--- 
+++ 
@@ -6,13 +6,6 @@
 list(SORT INSPIRCD_MODULES)
 
 add_definitions("-DDLL_BUILD")
-
-file(GLOB INSPIRCD_VENDORS "${INSPIRCD_BASE}/vendor/**")
-foreach(INSPIRCD_VENDOR ${INSPIRCD_VENDORS})
-	if(NOT IS_DIRECTORY ${INSPIRCD_VENDOR})
-		list(REMOVE_ITEM INSPIRCD_VENDORS ${INSPIRCD_VENDOR})
-	endif()
-endforeach()
 
 foreach(MODULE_NAME ${INSPIRCD_MODULES})
 	if(IS_DIRECTORY "${MODULE_NAME}")
@@ -33,7 +26,6 @@
 	# Generate the module and set its linker flags, also set it to depend on the main executable to be built beforehand
 	target_link_libraries(${SO_NAME} inspircd)
 	add_dependencies(${SO_NAME} inspircd)
-	target_include_directories(${SO_NAME} PRIVATE ${INSPIRCD_VENDORS})
 	if(MSVC)
 		target_link_libraries(${SO_NAME} win32_memory)
 		add_dependencies(${SO_NAME} win32_memory)

=== debian/changelog ===
inspircd (3.8.1-2) unstable; urgency=medium

  * Suggest 'geoip-database' as mentioned in #955479
  * Use /usr/bin/perl for 'inspircd-testssl'
  * New patch: stop suppressing stderr for some 'make' commands
  * Force /usr/lib/inspircd/inspircd executable, irrespective of umask
  * debian/patches: ship fix for SA-2021-01 cfr. https://docs.inspircd.org/security/2021-01/

 -- Filippo Giunchedi <filippo@debian.org>  Mon, 24 May 2021 09:42:36 +0200

inspircd (3.8.1-1) unstable; urgency=medium

  * New upstream release

 -- Filippo Giunchedi <filippo@debian.org>  Fri, 27 Nov 2020 15:43:06 +0100

inspircd (3.8.0-1) unstable; urgency=medium

  * New upstream release (Closes: #960650)
  * List all wanted extras, and fail if their dependencies are missing.
  * Restore missing extras (Closes: #953259)
  * Point VCS control fields to salsa.d.o repo
  * Set myself as Maintainer
  * Link httpd module with http_parser (Closes: #951339)

 -- Filippo Giunchedi <filippo@debian.org>  Fri, 20 Nov 2020 15:56:44 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: inspircd
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christoph Biedl <debian.axhn@manchmal.in-ulm.de>
+Maintainer: Filippo Giunchedi <filippo@debian.org>
 Homepage: https://www.inspircd.org/
 Standards-Version: 4.4.1
 Build-Depends: debhelper-compat (= 12),
@@ -14,11 +13,15 @@
     libpq-dev,
     libsqlite3-dev,
     libtre-dev,
+    libre2-dev,
+    libargon2-dev,
     perl,
     pkg-config,
     zlib1g-dev,
 Priority: optional
 Section: net
+Vcs-Browser: https://salsa.debian.org/debian/inspircd
+Vcs-Git: https://salsa.debian.org/debian/inspircd.git
 
 Package: inspircd
 Architecture: any
@@ -32,6 +35,7 @@
     ldap-server,
     postgresql,
     sqlite3,
+    geoip-database,
 Provides:
     ircd,
 Description: Modular IRCd written in C++

=== debian/rules ===
--- 
+++ 
@@ -23,16 +23,17 @@
 
 override_dh_auto_configure:
 	./configure --disable-interactive \
+		--enable-extras argon2,geo_maxmind,ldap,mysql,pgsql,regex_pcre,regex_posix,regex_re2,regex_stdlib,regex_tre,sqlite3,ssl_gnutls,sslrehashsignal
+	./configure --disable-interactive \
 		--uid=irc \
 		--gid=irc \
+		--disable-auto-extras \
 		--prefix=/usr/lib/inspircd \
 		--config-dir=/etc/inspircd \
 		--module-dir=/usr/lib/inspircd/modules \
 		--example-dir=/usr/share/doc/inspircd/examples \
 		--data-dir=/var/run/inspircd \
 		--binary-dir=/usr/sbin
-	./configure --disable-interactive \
-		--enable-extras=m_ldap.cpp,m_regex_stdlib.cpp
 
 override_dh_auto_build:
 	dh_auto_build -- INSPIRCD_VERBOSE=1 all
@@ -41,11 +42,15 @@
 	dh_auto_install
 	dh_apparmor --profile-name=usr.sbin.inspircd -pinspircd
 
+	# Make sure the Perl service wrapper is executable
+	chmod 755 $(CURDIR)/debian/tmp/usr/lib/inspircd/inspircd
+
 override_dh_installman:
 	mkdir build-man/
 	for man in \
 		inspircd.1 \
-		inspircd-genssl.1 ; \
+		inspircd-genssl.1 \
+		inspircd-testssl.1 ; \
 	do \
 		sed -e 's/"1"/"8"/' \
 			<"debian/tmp/usr/lib/inspircd/manuals/$$man" \

=== debian/watch ===
version=3
opts=uversionmangle=s/^(2\.1(?:fork|b[123]|a[12]))$/0.0.$1/ \
    https://github.com/inspircd/inspircd/releases \
    .*/archive/v([0-9.]+)\.tar\.gz

## inspircd 3.12.0

=== win/modules/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,26 @@
 # m_regex_stdlib is supported by every version of Visual Studio we support,
 # so copy the file out of extra/
 file(COPY "${INSPIRCD_BASE}/src/modules/extra/m_regex_stdlib.cpp" DESTINATION "${INSPIRCD_BASE}/src/modules/")
+
+if(EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
+	file(COPY "${INSPIRCD_BASE}/src/modules/extra/m_argon2.cpp" DESTINATION "${INSPIRCD_BASE}/src/modules/")
+	file(COPY "${INSPIRCD_BASE}/src/modules/extra/m_pgsql.cpp" DESTINATION "${INSPIRCD_BASE}/src/modules/")
+	file(COPY "${INSPIRCD_BASE}/src/modules/extra/m_mysql.cpp" DESTINATION "${INSPIRCD_BASE}/src/modules/")
+	file(COPY "${INSPIRCD_BASE}/src/modules/extra/m_regex_pcre.cpp" DESTINATION "${INSPIRCD_BASE}/src/modules/")
+	file(COPY "${INSPIRCD_BASE}/src/modules/extra/m_regex_re2.cpp" DESTINATION "${INSPIRCD_BASE}/src/modules/")
+	file(COPY "${INSPIRCD_BASE}/src/modules/extra/m_sqlite3.cpp" DESTINATION "${INSPIRCD_BASE}/src/modules/")
+
+	include("${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
+	link_directories("${CMAKE_BINARY_DIR}/extradll" "${CMAKE_BINARY_DIR}/extralib")
+
+	file(GLOB EXTRA_DLLS "${CMAKE_BINARY_DIR}/extradll/*.dll")
+	install(FILES ${EXTRA_DLLS} DESTINATION .)
+
+	conan_basic_setup(TARGETS)
+else()
+	message("Unable to build extras: conanbuildinfo.cmake does not exist in the build directory!")
+endif()
+
 
 file(GLOB INSPIRCD_MODULES "${INSPIRCD_BASE}/src/coremods/core_*" "${INSPIRCD_BASE}/src/modules/m_*")
 list(SORT INSPIRCD_MODULES)
@@ -31,6 +51,10 @@
 		add_dependencies(${SO_NAME} win32_memory)
 	endif(MSVC)
 
+	if(CONAN_CXX_FLAGS)
+		conan_target_link_libraries("${SO_NAME}")
+	endif()
+
 	set_target_properties(${SO_NAME} PROPERTIES
 		PREFIX ""
 		SUFFIX ""

=== debian/changelog ===
inspircd (3.12.0-1build1) jammy; urgency=medium

  * No-change rebuild to update maintainer scripts, see LP: 1959054

 -- Dave Jones <dave.jones@canonical.com>  Wed, 16 Feb 2022 17:03:47 +0000

inspircd (3.12.0-1) unstable; urgency=medium

  * New upstream release (Closes: #994813)
    + drop SA-2021-01 patch, applied upstream
    + refresh patches

  * Packaging improvements by Sadie Powell, including:
    + updated configuration
    + Depend on gnutls-bin at runtime
    + do not Suggest geoip-database since geoip v1 databases are not
    compatible with libmaxminddb

 -- Filippo Giunchedi <filippo@debian.org>  Sun, 09 Jan 2022 15:57:17 +0100

=== debian/control ===
--- 
+++ 
@@ -28,14 +28,14 @@
 Pre-Depends:
     ${misc:Pre-Depends},
 Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends},
+    gnutls-bin,
+    libio-socket-ssl-perl,
     lsb-base,
 Suggests:
     default-mysql-server,
-    gnutls-bin,
     ldap-server,
     postgresql,
     sqlite3,
-    geoip-database,
 Provides:
     ircd,
 Description: Modular IRCd written in C++

=== debian/rules ===
--- 
+++ 
@@ -28,6 +28,7 @@
 		--uid=irc \
 		--gid=irc \
 		--disable-auto-extras \
+		--distribution-label=debian \
 		--prefix=/usr/lib/inspircd \
 		--config-dir=/etc/inspircd \
 		--module-dir=/usr/lib/inspircd/modules \

## inspircd 3.15.0

=== win/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.8 FATAL_ERROR)
 
 project(InspIRCd CXX)
 
@@ -39,7 +39,7 @@
 	set(CMAKE_MODULE_LINKER_FLAGS_MINSIZEREL "${CMAKE_MODULE_LINKER_FLAGS_MINSIZEREL} /SAFESEH:NO")
 	set(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} /SAFESEH:NO")
 	set(CMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO} /SAFESEH:NO")
-endif(MSVC)
+endif()
 
 file(GLOB INSPIRCD_SOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
 "${INSPIRCD_BASE}/win/inspircd_win32wrapper.cpp"
@@ -62,7 +62,7 @@
 
 if(MSVC)
 	add_library(win32_memory STATIC "${INSPIRCD_BASE}/win/inspircd_memory_functions.cpp")
-endif(MSVC)
+endif()
 
 configure_file("${INSPIRCD_BASE}/win/inspircd.rc.cmake" "${INSPIRCD_BASE}/win/inspircd.rc")
 configure_file("${INSPIRCD_BASE}/make/template/config.h" "${INSPIRCD_BASE}/include/config.h")
@@ -70,7 +70,7 @@
 add_executable(inspircd ${INSPIRCD_SOURCES} "${INSPIRCD_BASE}/win/inspircd.rc")
 target_link_libraries(inspircd win32_memory)
 set_target_properties(inspircd PROPERTIES ENABLE_EXPORTS ON)
-install(TARGETS inspircd DESTINATION .)
+install(TARGETS inspircd RUNTIME DESTINATION .)
 
 add_subdirectory(modules)
 
@@ -79,12 +79,9 @@
 install(FILES ${EXTRA_DLLS} DESTINATION .)
 
 # Install example configs
-file(GLOB_RECURSE EXAMPLE_CONFIGS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${INSPIRCD_BASE}/docs/conf/*.example")
-install(FILES ${EXAMPLE_CONFIGS} DESTINATION conf)
-
-# Install nationalchars files
-file(GLOB_RECURSE EXAMPLE_LOCALES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${INSPIRCD_BASE}/locales/*")
-install(FILES ${EXAMPLE_LOCALES} DESTINATION locales)
+install(DIRECTORY "${INSPIRCD_BASE}/docs/conf/" DESTINATION "${CONFIG_DIR}/examples")
+install(DIRECTORY "${INSPIRCD_BASE}/docs/sql/" DESTINATION "${CONFIG_DIR}/sql")
+install(DIRECTORY "${INSPIRCD_BASE}/locales/" DESTINATION "${CONFIG_DIR}/locales")
 
 # Create an empty data and logs directory and install them
 file(MAKE_DIRECTORY ${DATA_DIR})
@@ -115,4 +112,4 @@
 	set(CPACK_NSIS_COMPRESSOR "/SOLID zlib")
 
 	include(CPack)
-endif(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")
+endif()

=== win/modules/CMakeLists.txt ===
# These modules can always be built on all platforms.
file(GLOB INSPIRCD_MODULES
	"${INSPIRCD_BASE}/src/coremods/core_*"
	"${INSPIRCD_BASE}/src/modules/m_*")

# These modules have their dependencies provided by Windows.
list(APPEND INSPIRCD_MODULES
	"${INSPIRCD_BASE}/src/modules/extra/m_ldap.cpp"
	"${INSPIRCD_BASE}/src/modules/extra/m_regex_stdlib.cpp")

if(EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
	include("${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")

	function(enable_extra NAME PACKAGE)
		if(DEFINED "CONAN_${PACKAGE}_ROOT")
			message("Enabling the ${NAME} module")
			list(APPEND INSPIRCD_MODULES "${INSPIRCD_BASE}/src/modules/extra/m_${NAME}.cpp")
			set(INSPIRCD_MODULES ${INSPIRCD_MODULES} PARENT_SCOPE)
		else()
			message("Unable to enable the ${NAME} module (missing library)")
		endif()
	endfunction()

	enable_extra("argon2" "ARGON2")
	enable_extra("geo_maxmind" "LIBMAXMINDDB")
	enable_extra("mysql" "LIBMYSQLCLIENT")
	enable_extra("pgsql" "LIBPQ")
	enable_extra("regex_pcre" "PCRE")
	enable_extra("regex_pcre2" "PCRE2")
	enable_extra("regex_posix" "PCRE2")
	enable_extra("regex_re2" "RE2")
	enable_extra("ssl_mbedtls" "MBEDTLS")
	enable_extra("ssl_openssl" "OPENSSL")
	enable_extra("sqlite3" "SQLITE3")

	link_directories("${CMAKE_BINARY_DIR}/extradll" "${CMAKE_BINARY_DIR}/extralib")
	file(GLOB EXTRA_DLLS "${CMAKE_BINARY_DIR}/extradll/*.dll")
	install(FILES ${EXTRA_DLLS} DESTINATION .)

	conan_basic_setup(TARGETS)
else()
	message("Unable to build extras: conanbuildinfo.cmake does not exist in the build directory!")
endif()

list(SORT INSPIRCD_MODULES)

add_definitions("-DDLL_BUILD")

foreach(MODULE_NAME ${INSPIRCD_MODULES})
	if(IS_DIRECTORY "${MODULE_NAME}")
		string(REGEX REPLACE "^.*[/\\](.*)$" "\\1" BASE_NAME ${MODULE_NAME})
	else()
		string(REGEX REPLACE "^.*[/\\](.*).cpp$" "\\1" BASE_NAME ${MODULE_NAME})
	endif()
	set(SO_NAME "${BASE_NAME}.so")

	if(IS_DIRECTORY "${MODULE_NAME}")
		file(GLOB MODULES_SUBDIR_SRCS "${MODULE_NAME}/*.cpp")
		list(SORT MODULES_SUBDIR_SRCS)
		add_library(${SO_NAME} MODULE ${MODULES_SUBDIR_SRCS})
	else()
		add_library(${SO_NAME} MODULE ${MODULE_NAME})
	endif()

	# Generate the module and set its linker flags, also set it to depend on the main executable to be built beforehand
	target_link_libraries(${SO_NAME} inspircd)
	add_dependencies(${SO_NAME} inspircd)
	if(MSVC)
		target_link_libraries(${SO_NAME} win32_memory)
		add_dependencies(${SO_NAME} win32_memory)
	endif()

	if(CONAN_CXX_FLAGS)
		conan_target_link_libraries("${SO_NAME}")
	endif()

	set_target_properties(${SO_NAME} PROPERTIES
		PREFIX ""
		SUFFIX ""
		COMPILE_DEFINITIONS "MODNAME=\"${BASE_NAME}\""
	)

	# Set the module to be installed to the module directory
	install(TARGETS ${SO_NAME} DESTINATION ${MODULE_DIR} LIBRARY)
endforeach()

=== debian/changelog ===
inspircd (3.15.0-1) unstable; urgency=medium

  * New upstream release
    + build libpcre2-dev, not libpcre3-dev (Closes: #1000104)
    + ship upstream apparmor configuration (Closes: #955479)
  * apparmor: allow local includes, part of #955479

 -- Filippo Giunchedi <filippo@debian.org>  Sun, 15 Jan 2023 16:05:01 +0100

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,12 @@
 Build-Depends: debhelper-compat (= 12),
     default-libmysqlclient-dev,
     dh-apparmor,
+    dh-exec,
     libgnutls28-dev,
     libhttp-parser-dev (>= 2.9),
     libldap2-dev,
     libmaxminddb-dev,
-    libpcre3-dev,
+    libpcre2-dev,
     libpq-dev,
     libsqlite3-dev,
     libtre-dev,

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 
 override_dh_auto_configure:
 	./configure --disable-interactive \
-		--enable-extras argon2,geo_maxmind,ldap,mysql,pgsql,regex_pcre,regex_posix,regex_re2,regex_stdlib,regex_tre,sqlite3,ssl_gnutls,sslrehashsignal
+		--enable-extras argon2,geo_maxmind,ldap,mysql,pgsql,regex_pcre2,regex_posix,regex_re2,regex_stdlib,regex_tre,sqlite3,ssl_gnutls,sslrehashsignal
 	./configure --disable-interactive \
 		--uid=irc \
 		--gid=irc \

## inspircd 3.17.0

=== win/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,25 @@
+#
+# InspIRCd -- Internet Relay Chat Daemon
+#
+#   Copyright (C) 2019 Robby <robby@chatbelgie.be>
+#   Copyright (C) 2015, 2018-2019, 2022 Sadie Powell <sadie@witchery.services>
+#   Copyright (C) 2013-2014, 2017 Adam <Adam@anope.org>
+#   Copyright (C) 2013-2014 Attila Molnar <attilamolnar@hush.com>
+#
+# This file is part of InspIRCd.  InspIRCd is free software: you can
+# redistribute it and/or modify it under the terms of the GNU General Public
+# License as published by the Free Software Foundation, version 2.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+
 cmake_minimum_required(VERSION 3.8 FATAL_ERROR)
 
 project(InspIRCd CXX)

=== debian/changelog ===
inspircd (3.17.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:25:28 +0000

inspircd (3.17.0-1build1) noble; urgency=medium

  * No-change rebuild against libgnutls30t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 10 Mar 2024 02:06:22 +0000

inspircd (3.17.0-1) unstable; urgency=medium

  * New upstream release
    + Remove deprecated directives from default configuration file
  * Allow apparmor access to /var/log/inspircd.log (Closes: #1040954)

 -- Filippo Giunchedi <filippo@debian.org>  Sun, 21 Jan 2024 17:01:14 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: inspircd
-Maintainer: Filippo Giunchedi <filippo@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Filippo Giunchedi <filippo@debian.org>
 Homepage: https://www.inspircd.org/
 Standards-Version: 4.4.1
 Build-Depends: debhelper-compat (= 12),
@@ -31,7 +32,6 @@
 Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends},
     gnutls-bin,
     libio-socket-ssl-perl,
-    lsb-base,
 Suggests:
     default-mysql-server,
     ldap-server,

=== debian/rules ===
--- 
+++ 
@@ -47,7 +47,7 @@
 	chmod 755 $(CURDIR)/debian/tmp/usr/lib/inspircd/inspircd
 
 override_dh_installman:
-	mkdir build-man/
+	install -d build-man/
 	for man in \
 		inspircd.1 \
 		inspircd-genssl.1 \

=== debian/watch ===
version=4
https://github.com/inspircd/inspircd/tags \
  /inspircd/inspircd/archive/refs/tags/v([0-9.]+)\.tar\.gz

## inspircd 4.7.0+ds1

=== win/CMakeLists.txt ===
#
# InspIRCd -- Internet Relay Chat Daemon
#
#   Copyright (C) 2019 Robby <robby@chatbelgie.be>
#   Copyright (C) 2018-2019, 2021-2024 Sadie Powell <sadie@witchery.services>
#   Copyright (C) 2013-2014 Attila Molnar <attilamolnar@hush.com>
#   Copyright (C) 2013-2014 Adam <Adam@anope.org>
#
# This file is part of InspIRCd.  InspIRCd is free software: you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


cmake_minimum_required(VERSION 3.20 FATAL_ERROR)

project("InspIRCd" CXX)

if(NOT WIN32)
	message(FATAL_ERROR "CMake can only be used on Windows!")
endif()

set(CONFIG_DIR "conf" CACHE PATH "Configuration path")
set(MODULE_DIR "modules" CACHE PATH "Module path")
set(DATA_DIR "data" CACHE PATH "Data path")
set(LOG_DIR "logs" CACHE PATH "Log path")

# Find the root of the source directory
cmake_path(GET CMAKE_CURRENT_SOURCE_DIR PARENT_PATH INSPIRCD_BASE)

# Build with multiple processes
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

# Use our own NSIS template
set(CMAKE_MODULE_PATH "${INSPIRCD_BASE}/win")

# Require C++17
set(CMAKE-CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD "17")
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Put modules in their own folder
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

add_compile_definitions(
	"_WIN32_WINNT=0x0A00"      # Set the minimum OS to Windows 10
	"FD_SETSIZE=24000"         # Increase the default socket limit to something reasonable
	"NOMINMAX"                 # Avoid the Windows API breaking std::{min,max}
	"NTDDI_VERSION=0x0A000005" # Set the minimum OS to Windows 10 1803 "Redstone 4"
	"WIN32_LEAN_AND_MEAN"      # Trim down the size of the included headers.
)

add_compile_options("/utf-8")

include_directories("${INSPIRCD_BASE}/win" "${INSPIRCD_BASE}/include")
include_directories(SYSTEM "${INSPIRCD_BASE}/vendor")

# win32memory is statically linked into every target later
add_library("win32memory" STATIC "${INSPIRCD_BASE}/win/win32memory.cpp")

# Grab version info from version.sh
file(STRINGS "${INSPIRCD_BASE}/src/version.sh" VERSIONSH)
string(REGEX REPLACE ".*InspIRCd-([0-9]*).*" "\\1" VERSION_MAJOR "${VERSIONSH}")
string(REGEX REPLACE ".*InspIRCd-[0-9]*\\.([0-9]*).*" "\\1" VERSION_MINOR "${VERSIONSH}")
string(REGEX REPLACE ".*InspIRCd-[0-9]*\\.[0-9]*\\.([0-9]*).*" "\\1" VERSION_PATCH "${VERSIONSH}")
string(REGEX REPLACE ".*InspIRCd-([^\"]+).*" "\\1" VERSION_FULL "${VERSIONSH}")

# Preconfigure files that the InspIRCd build needs.
configure_file("${INSPIRCD_BASE}/make/template/config.h" "${INSPIRCD_BASE}/include/config.h")
configure_file("${INSPIRCD_BASE}/win/inspircd.rc.cmake" "${INSPIRCD_BASE}/win/inspircd.rc")

file(GLOB INSPIRCD_HEADERS
	"${INSPIRCD_BASE}/include/*.h"
	"${INSPIRCD_BASE}/include/modules/*.h"
	"${INSPIRCD_BASE}/include/utility/*.h"
)
list(SORT INSPIRCD_HEADERS)

file(GLOB INSPIRCD_SOURCES
	"${INSPIRCD_BASE}/src/*.cpp"
	"${INSPIRCD_BASE}/src/socketengines/select.cpp"
	"${INSPIRCD_BASE}/win/win32wrapper.cpp"
	"${INSPIRCD_BASE}/win/win32service.cpp"
)
list(SORT INSPIRCD_SOURCES)

# The main server executable
add_executable("inspircd" ${INSPIRCD_HEADERS} ${INSPIRCD_SOURCES} "${INSPIRCD_BASE}/win/inspircd.rc")
add_dependencies("inspircd" "win32memory")
target_compile_definitions("inspircd" PRIVATE "FMT_LIB_EXPORT" "INSPIRCD_CORE")
set_target_properties("inspircd" PROPERTIES "ENABLE_EXPORTS" ON)
target_link_libraries("inspircd" "win32memory")
install(TARGETS "inspircd" RUNTIME DESTINATION ".")

# Also build modules
add_subdirectory("modules")

# Package any DLLs from Conan
file(GLOB EXTRA_DLLS "${CMAKE_CURRENT_SOURCE_DIR}/*.dll")
install(FILES ${EXTRA_DLLS} DESTINATION ".")

# Install example configs
install(DIRECTORY "${INSPIRCD_BASE}/docs/conf/" DESTINATION "${CONFIG_DIR}/examples")
install(DIRECTORY "${INSPIRCD_BASE}/docs/sql/" DESTINATION "${CONFIG_DIR}/sql")

# Create an empty data and logs directory and install them
file(MAKE_DIRECTORY ${DATA_DIR})
install(DIRECTORY ${DATA_DIR} DESTINATION .)
file(MAKE_DIRECTORY ${LOG_DIR})
install(DIRECTORY ${LOG_DIR} DESTINATION .)

if(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")
	# Place runtime libraries next to the InspIRCd binary
	set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION ".")
	include("InstallRequiredSystemLibraries")

	set(CPACK_PACKAGE_NAME "InspIRCd -- Internet Relay Chat Daemon")
	set(CPACK_PACKAGE_VENDOR "InspIRCd Team")
	set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
	set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
	set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
	set(CPACK_PACKAGE_FILE_NAME "InspIRCd-${VERSION_FULL}")
	set(CPACK_RESOURCE_FILE_LICENSE "${INSPIRCD_BASE}/docs/LICENSE.txt")

	set(CPACK_GENERATOR "NSIS")
	set(CPACK_PACKAGE_INSTALL_DIRECTORY "InspIRCd")
	# NSIS has a bug with full nix paths, so this must contain at least one backslash
	set(CPACK_PACKAGE_ICON "${INSPIRCD_BASE}/win\\\\inspircd.ico")
	set(CPACK_NSIS_MUI_ICON "${INSPIRCD_BASE}/win\\\\inspircd.ico")
	set(CPACK_NSIS_MUI_UNIICON "${INSPIRCD_BASE}/win\\\\inspircd.ico")
	set(CPACK_NSIS_INSTALLED_ICON_NAME "inspircd.exe")
	set(CPACK_NSIS_URL_INFO_ABOUT "https://www.inspircd.org")
	set(CPACK_NSIS_COMPRESSOR "/SOLID zlib")

	include("CPack")
endif()

=== win/modules/CMakeLists.txt ===
#
# InspIRCd -- Internet Relay Chat Daemon
#
#   Copyright (C) 2021-2024 Sadie Powell <sadie@witchery.services>
#   Copyright (C) 2013-2014 Attila Molnar <attilamolnar@hush.com>
#   Copyright (C) 2013 Adam <Adam@anope.org>
#
# This file is part of InspIRCd.  InspIRCd is free software: you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


# These modules can always be built on all platforms
file(GLOB INSPIRCD_MODULES
	"${INSPIRCD_BASE}/src/coremods/core_*"
	"${INSPIRCD_BASE}/src/modules/m_*")

# These modules have their dependencies provided by Windows
list(APPEND INSPIRCD_MODULES
	"${INSPIRCD_BASE}/src/modules/extra/m_ldap.cpp")

if(EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
	include("${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")

	function(enable_extra NAME PACKAGE)
		if(DEFINED "CONAN_${PACKAGE}_ROOT")
			message("Enabling the ${NAME} module")
			list(APPEND INSPIRCD_MODULES "${INSPIRCD_BASE}/src/modules/extra/m_${NAME}.cpp")
			set(INSPIRCD_MODULES ${INSPIRCD_MODULES} PARENT_SCOPE)
		else()
			message("Unable to enable the ${NAME} module (missing library)")
		endif()
	endfunction()

	enable_extra("argon2" "ARGON2")
	enable_extra("geo_maxmind" "LIBMAXMINDDB")
	enable_extra("log_json" "YYJSON")
	enable_extra("mysql" "LIBMYSQLCLIENT")
	enable_extra("pgsql" "LIBPQ")
	enable_extra("regex_pcre2" "PCRE2")
	enable_extra("regex_posix" "PCRE2")
	enable_extra("regex_re2" "RE2")
	enable_extra("ssl_openssl" "OPENSSL")
	enable_extra("sqlite3" "SQLITE3")

	link_directories("${CMAKE_BINARY_DIR}/extradll" "${CMAKE_BINARY_DIR}/extralib")
	file(GLOB EXTRA_DLLS "${CMAKE_BINARY_DIR}/extradll/*.dll")
	install(FILES ${EXTRA_DLLS} DESTINATION .)

	conan_basic_setup(TARGETS)
else()
	message("Unable to build extras: conanbuildinfo.cmake does not exist in the build directory!")
endif()

list(SORT INSPIRCD_MODULES)

foreach(MODULE_NAME ${INSPIRCD_MODULES})
	if(IS_DIRECTORY "${MODULE_NAME}")
		string(REGEX REPLACE "^.*[/\\](.*)$" "\\1" BASE_NAME ${MODULE_NAME})
	else()
		string(REGEX REPLACE "^.*[/\\](.*).cpp$" "\\1" BASE_NAME ${MODULE_NAME})
	endif()

	if(IS_DIRECTORY "${MODULE_NAME}")
		file(GLOB MODULES_SUBDIR_SRCS "${MODULE_NAME}/*.cpp")
		list(SORT MODULES_SUBDIR_SRCS)
		add_library(${BASE_NAME} MODULE ${MODULES_SUBDIR_SRCS})
	else()
		add_library(${BASE_NAME} MODULE ${MODULE_NAME})
	endif()

	# Link against the core and memory library
	add_dependencies(${BASE_NAME} "inspircd" "win32memory")
	target_link_libraries(${BASE_NAME} "inspircd" "win32memory")

	# Link against any dependencies if available
	if(CONAN_CXX_FLAGS)
		conan_target_link_libraries(${BASE_NAME})
	endif()

	set_target_properties(${BASE_NAME} PROPERTIES
		PREFIX ""
		FOLDER "Modules"
		COMPILE_DEFINITIONS "FMT_SHARED;MODNAME=\"${BASE_NAME}\""
	)

	# Set the module to be installed to the module directory
	install(TARGETS ${BASE_NAME} LIBRARY DESTINATION ${MODULE_DIR})
endforeach()

=== debian/changelog ===
inspircd (4.7.0+ds1-2build1) questing; urgency=medium

  * Rebuild against latest abseil

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 04 May 2025 08:17:21 -0400

inspircd (4.7.0+ds1-2) unstable; urgency=medium

  * Clean contrib modules in debian/rules

 -- Filippo Giunchedi <filippo@debian.org>  Wed, 02 Apr 2025 13:01:46 +0200

inspircd (4.7.0+ds1-1) unstable; urgency=medium

  * New upstream version

 -- Filippo Giunchedi <filippo@debian.org>  Sun, 30 Mar 2025 18:23:48 +0200

inspircd (4.6.0+ds1-1) unstable; urgency=medium

  * New upstream release (Closes: #1099209)
    + Change 'admin:nick' to 'admin:description' in inspircd.conf
    + 'regex_pcre' removed in favor of 'regex_pcre2'
    + 'regex_tre' removed
    + New modules: 'log_syslog' and 'log_json'
    + See also https://docs.inspircd.org/4/overview/
  * The inspircd-genssl binary is no longer shipped upstream
  * Include Debian package version in ./configure --distribution-label
  * The +ds1 source package contains a contrib/ git subtree from
    https://github.com/inspircd/inspircd-contrib used to ship a selection of
    modules.

 -- Filippo Giunchedi <filippo@debian.org>  Wed, 26 Mar 2025 22:01:17 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: inspircd
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Filippo Giunchedi <filippo@debian.org>
+Maintainer: Filippo Giunchedi <filippo@debian.org>
 Homepage: https://www.inspircd.org/
 Standards-Version: 4.4.1
 Build-Depends: debhelper-compat (= 12),
@@ -9,16 +8,17 @@
     dh-exec,
     libgnutls28-dev,
     libhttp-parser-dev (>= 2.9),
+    libutfcpp-dev,
     libldap2-dev,
     libmaxminddb-dev,
     libpcre2-dev,
     libpq-dev,
     libsqlite3-dev,
-    libtre-dev,
     libre2-dev,
     libargon2-dev,
+    libyyjson-dev | librapidjson-dev,
     perl,
-    pkg-config,
+    pkgconf,
     zlib1g-dev,
 Priority: optional
 Section: net
